// ============================================================================================================
// IDS Webhelp scripting
// KdG Eluxis.com
// ============================================================================================================

/* *************************************** */
/* Global variables */
/* *************************************** */
var historie = new Array();
var historiecurrent = 0;


// ============================================================================================================
// Determine display mode: mobile of full desktop 
// ============================================================================================================
var mobile=true; //default is mobile
if (window.location.href.search(/device=full/) != -1) {//URL contains "device=full"
	mobile=false;
}
else { 
	if (window.location.href.search(/device=mobile/) == -1) {//URL does not contain "device=mobile"
		if (devicetest()=="desktop") {//Device is a desktop
			mobile=false;
		}
	}
}

function init() {
	if (mobile==false) {
		//hide icon to show content pane
		var el = document.getElementById("a_content");if (el) el.style.display = 'none';	
	}
}

function devicetest() {
	//Test which device the page is viewed on.
	//Adapted (KdG) from Categorizr.js: Device Detection Scripts | https://github.com/Skookum/categorizr.js
	ua = ( window.navigator ? window.navigator.userAgent : window.request ? window.request.headers['user-agent'] : 'No User-Agent Provided' )
	return  ua.match(/GoogleTV|SmartTV|Internet.TV|NetCast|NETTV|AppleTV|boxee|Kylo|Roku|DLNADOC|CE\-HTML/i) ? 'tv'// smart tv
	: ua.match(/Xbox|PLAYSTATION.3|Wii/i) ? 'tv'// tv-based gaming console
	: ua.match(/iPad/i) || ua.match(/tablet/i) && !ua.match(/RX-34/i) || ua.match(/FOLIO/i) ? 'tablet'// tablet
	: ua.match(/Linux/i) && ua.match(/Android/i) && !ua.match(/Fennec|mobi|HTC.Magic|HTCX06HT|Nexus.One|SC-02B|fone.945/i) ? 'tablet'// android tablet
	: ua.match(/Kindle/i) || ua.match(/Mac.OS/i) && ua.match(/Silk/i) ? 'tablet'// Kindle or Kindle Fire
	: ua.match(/GT-P10|SC-01C|SHW-M180S|SGH-T849|SCH-I800|SHW-M180L|SPH-P100|SGH-I987|zt180|HTC(.Flyer|\_Flyer)|Sprint.ATP51|ViewPad7|pandigital(sprnova|nova)|Ideos.S7|Dell.Streak.7|Advent.Vega|A101IT|A70BHT|MID7015|Next2|nook/i) || ua.match(/MB511/i) && ua.match(/RUTEM/i) ? 'tablet'// pre Android 3.0 Tablet
	: ua.match(/BOLT|Fennec|Iris|Maemo|Minimo|Mobi|mowser|NetFront|Novarra|Prism|RX-34|Skyfire|Tear|XV6875|XV6975|Google.Wireless.Transcoder/i) ? 'mobile'// unique Mobile User Agent
	: ua.match(/Opera/i) && ua.match(/Windows.NT.5/i) && ua.match(/HTC|Xda|Mini|Vario|SAMSUNG\-GT\-i8000|SAMSUNG\-SGH\-i9/i) ? 'mobile'// odd Opera User Agent - http://goo.gl/nK90K
	: ua.match(/Windows.(NT|XP|ME|9)/) && !ua.match(/Phone/i) || ua.match(/Win(9|.9|NT)/i) ? 'desktop'// Windows Desktop
	: ua.match(/Macintosh|PowerPC/i) && !ua.match(/Silk/i) ? 'desktop'// Mac Desktop
	: ua.match(/Linux/i) && ua.match(/X11/i) ? 'desktop'// Linux Desktop
	: ua.match(/Solaris|SunOS|BSD/i) ? 'desktop'// Solaris, SunOS, BSD Desktop
	: ua.match(/Bot|Crawler|Spider|Yahoo|ia_archiver|Covario-IDS|findlinks|DataparkSearch|larbin|Mediapartners-Google|NG-Search|Snappy|Teoma|Jeeves|TinEye/i) && !ua.match(/Mobile/i) ? 'desktop'// Desktop BOT/Crawler/Spider
	: 'mobile';// assume it is a Mobile Device (mobile-first)
}

// ============================================================================================================
// WebHelp Display functions
// IDS webhelp for mobile and desctop show screen handling
// ============================================================================================================
function showToc() {
	//Select the currently displayed content topic in the Toc
	var tocroot = document.getElementById("toccontainer");
	try {
		var target = window.mainframe.location.href.split('#')[0]; //url without hash
		if (tocroot) {expandToItemURL(target,tocroot);}
	}
	catch(e) {}
	//Display the TOC, hide the rest (for mobile)
	var el;
	el = document.getElementById("toccontainer"); if (el) el.style.display = 'block';	
	el = document.getElementById("TOCexpandcollapseAll"); if (el) el.style.display = 'block';
	el = document.getElementById("resultcontainer");	if (el) el.style.display = 'none';
	el = document.getElementById("indexcontainer");	if (el) el.style.display = 'none';
	if (mobile) {
		el = document.getElementById("contentwrapper"); if (el) el.style.display = "none";
		//document.getElementById("contentframe").src= ""; //Voorkom flickering, dat je steeds even het oude topic te zien krijgt bij navigeren-switchen 
//		el = document.getElementById("breadcrumbcontainer"); if (el) el.style.display = 'none';
	}
	el = document.getElementById("a_toc");    if (el) el.style.backgroundPosition = '-70px 3px';
	el = document.getElementById("a_index");  if (el) el.style.backgroundPosition = '0px -47px';
	el = document.getElementById("a_content");if (el) el.style.backgroundPosition = '0px -97px';
	el = document.getElementById("a_search");if (el) el.style.backgroundPosition = '-8px -147px';
}

function showIndex() {
	//Make cloud	
	//Display the index, hide the rest (for mobile)
	var el;
	el = document.getElementById("indexcontainer");	if (el) el.style.display = 'block';
	if (mobile) {
		el = document.getElementById("TOCexpandcollapseAll"); if (el) el.style.display = 'none';
		el = document.getElementById("toccontainer"); if (el) el.style.display = 'none';
		el = document.getElementById("resultcontainer");	if (el) el.style.display = 'none';
		el = document.getElementById("contentwrapper"); if (el) el.style.display = "none";
		//document.getElementById("contentframe").src= ""; //Voorkom flickering, dat je steeds even het oude topic te zien krijgt bij navigeren-switchen 
//		el = document.getElementById(" crumbcontainer"); if (el) el.style.display = 'none';
	}
	el = document.getElementById("a_toc");    if (el) el.style.backgroundPosition = '0px 3px';
	el = document.getElementById("a_index");  if (el) el.style.backgroundPosition = '-70px -47px';
	el = document.getElementById("a_content");if (el) el.style.backgroundPosition = '0px -97px';
	el = document.getElementById("a_search");if (el) el.style.backgroundPosition = '-8px -147px';
}

function showSearchResult() {
	//Display the serach result, hide the rest (for mobile)
	var el;
	el = document.getElementById("resultcontainer");	if (el) el.style.display = 'block';
	el = document.getElementById("toccontainer"); if (el) el.style.display = 'none';
	el = document.getElementById("indexcontainer");	if (el) el.style.display = 'none';
	if (mobile) {
		el = document.getElementById("TOCexpandcollapseAll"); if (el) el.style.display = 'none';
		el = document.getElementById("contentwrapper"); if (el) el.style.display = "none";
		//document.getElementById("contentframe").src= ""; //Voorkom flickering, dat je steeds even het oude topic te zien krijgt bij navigeren-switchen 
//		el = document.getElementById("breadcrumbcontainer"); if (el) el.style.display = 'none';
	}
	el = document.getElementById("a_toc");    if (el) el.style.backgroundPosition = '0px 3px';
	el = document.getElementById("a_index");  if (el) el.style.backgroundPosition = '0px -47px';
	el = document.getElementById("a_content");if (el) el.style.backgroundPosition = '0px -97px';
	el = document.getElementById("a_search");if (el) el.style.backgroundPosition = '-78px -147px';
}


function showContent(omithistory) {
	//Display the requested content, hide the rest (for mobile)
	if (mobile) {
		el = document.getElementById("contentwrapper");	if (el) el.style.display = 'block';//for mobile
		el = document.getElementById("toccontainer"); if (el) el.style.display = 'none';
		el = document.getElementById("TOCexpandcollapseAll"); if (el) el.style.display = 'none';
		el = document.getElementById("indexcontainer");	if (el) el.style.display = 'none';
		el = document.getElementById("resultcontainer");	if (el) el.style.display = 'none';
//		el = document.getElementById("breadcrumbcontainer"); if (el) el.style.display = 'block';
	}
	el = document.getElementById("a_toc");    if (el) el.style.backgroundPosition = '0px 3px';
	el = document.getElementById("a_index");  if (el) el.style.backgroundPosition = '0px -47px';
	el = document.getElementById("a_content");if (el) el.style.backgroundPosition = '-70px -97px';
	el = document.getElementById("a_search");if (el) el.style.backgroundPosition = '-8px -147px';
	//Add history
	if (!omithistory) {
		var mframe = window.mainframe;
		var mfHref = mframe.location.href;
		if (mfHref != historie[historiecurrent]) {
			//add the current
			historie.push(window.mainframe.location.href);
			if (historie.length > 20) {historie = historie.slice(historie.length-20);}
			historiecurrent = historie.length-1;
		}
	}
	document.location.hash = "top";//set view to top of page (<div id="top")
}

function showInfo() {
	//Display the metadata info of this WebHelp
	if (info) alert(info);
}

function dohistory(dir) {
	if (historiecurrent == historie.length-1) {
		if (window.mainframe.location.href != historie[historiecurrent]) {
			//add the current
			historie.push(window.mainframe.location.href);
			if (historie.length > 20) {historie = historie.slice(historie.length-20);}
			historiecurrent = historie.length-1;
		}
	}
	if (dir==1) {
		if (historiecurrent < historie.length-1) {
			historiecurrent++;
			window.mainframe.location.href = historie[historiecurrent];
			showContent(true); 
			var tocroot = document.getElementById("toccontainer");
			if(tocroot == null){
				alert("Error: elementId toccontainer not found");
				return false;
			}
			else {
				expandToItemURL(historie[historiecurrent],tocroot);
			}
		}
	}
	else {
		if (historiecurrent > 0) { 
			historiecurrent--;
			window.mainframe.location.href = historie[historiecurrent];
			showContent(true); 
			var tocroot = document.getElementById("toccontainer");
			if(tocroot == null){
				alert("Error: elementId toccontainer not found");
				return false;
			}
			else {
				expandToItemURL(historie[historiecurrent],tocroot);
			}
		}
	}
//var msg = historie.length+" items\n\n"
//for (i=0; i<historie.length; i++) {msg+= i+"\t"+historie[i]+"\n"}
//alert(msg+historiecurrent+"/"+historie.length+"\n"+historie[historiecurrent])
}


// ============================================================================================================
// DHTML expandable tree
// KdG Eluxis.com
// Tested on IE8,9,10,11 FF16, Chrome, Safari
// Tree structure is a normal unordered html list.
// The output is controlled by the CSS classes.
// ============================================================================================================
var OpenClass= "liOpen";
var ClosedClass="liClosed";
var SelectedClass = "selected";

/* **************************************** */
/* Thow clicked topic or expand/collapse    */
/* **************************************** */
function toggleView(node) {
	var tocroot = document.getElementById("toccontainer");
	if(tocroot == null){
		alert("Error: elementId toccontainer not found");
		return false;
	}
	var item = node.parentNode;
	if (hasClass(item,"liBullet")) {
		//Display the content
		resetSelected(tocroot);
		addClass(node,SelectedClass);
		showContent(); 
	}
	else {//Expand or collapse
		var togglecontainer = $(item).children("ul:first")
		if (hasClass(item,OpenClass)) {
			ahref = node.getElementsByTagName("a")[0];
			if (ahref) {
				showContent(); 
			}
			togglecontainer.slideUp("slow",function() {
				toggleClass(item,OpenClass,ClosedClass);
			});
		}
		else {
			togglecontainer.slideDown("slow",function(){
				if (hasClass(item,ClosedClass)){
					toggleClass(item,ClosedClass,OpenClass)
				};
			});
			//Reset collapse All as default
			collapseAll = true;
			el = document.getElementById("TOCexpandcollapseAll"); 
			if (el) {
				el.className = 'TOCcollapseAll'; 
				el.title='Collapse All';
			}
		}
		resetSelected(tocroot);
		addClass(node,SelectedClass);
	}
	return true;
}

function resetSelected(tocroot) {
	if(tocroot == null){
		alert("Error: elementId tocroot not found2");
		return false;
	}
	var els = tocroot.getElementsByTagName("*");
	var node;
	var re = new RegExp('(\\s|^)'+SelectedClass+'(\\s|$)');
	for(var i=0; i<els.length; i++) {
		node=els[i];
		if (node.className.match(re)) {
			removeClass(els[i],SelectedClass);
		}
	}
}

function Initial_expand_check() {
/* **************************************** */
/*Find target topic that is the default first page
  Expand the tree with the topic found in the main frame
  This is relevant for when the file is opened (e.g. through asp) with another than the first topic in the main frame*/
/* **************************************** */
	var target = "";
	var found = false;
	var tocroot = document.getElementById("toccontainer");
	if(tocroot == null){
		alert("Error: elementId toccontainer not found");
		return false;
	}

	try {
		//Check URL for ?target=
		var url = window.location; 
		var str = url.toString(); 
		str = str.replace(/#top/,"");//remove #top hash
		var p1 = str.indexOf("?target="); 
		if (p1!=-1) {
			p2 =str.indexOf("&",p1+1); 
			if (p2==-1) {
				target=str.substring(p1+8)
			} 
			else {
				target=str.substring(p1+8,p2);
			}
			if (target.indexOf(".htm")==-1) {
				target=target+".htm";
			}
			found = expandToItemURL(target,tocroot);
		}	
		if (found==false) {//Check for notoc entries
			var notocs=document.getElementsByTagName("var");
			for (i=0; i<notocs.length; i++) {
				if (target.search(notocs.item(i).title)!=-1) {
					target=notocs.item(i).title;
					found=true;
					break;
				}
			}
		}
		if (found==false) {//Take first entry in toc
			var ahrefs = tocroot.getElementsByTagName("a");
			target = ahrefs[0].href;
			found = expandToItemURL(target,tocroot);
		}
		if (found==false) {//Check for default main href (set in index.htm
			// Cross domain possible FIXME
			var mfloc = window.parent.mainframe.location;
			target = mfloc.href;
			if (target.indexOf(".htm")==-1) {
				target += ".htm";
			}
			found = expandToItemURL(target,tocroot);
		}
	}
	catch(e) {//if target file does not exist, or somethong else goes wrong (404)
	}
	if (found) {
		document.getElementById("contentframe").src= target;
		var contentFrame = document.getElementById("contentframe");
		contentFrame.src = contentFrame.src; //refresh page
	}
}


/* **************************************** */
/* Expand/collapse All                      */
/* **************************************** */
var collapseAll = true //Start with default 
function expandcollapseAll() {
	var tocroot = document.getElementById("toccontainer");
	var uls = tocroot.getElementsByTagName("ul");
	var lis = tocroot.getElementsByTagName("li");
	var i;
	if (collapseAll==false) {
		for(i=1;i<uls.length;i++){
			uls.item(i).style.display="block";
		}
		for(i=0;i<lis.length;i++){
			toggleClass(lis.item(i),ClosedClass,OpenClass);
		}
		collapseAll = true;
		el = document.getElementById("TOCexpandcollapseAll"); 
		if (el) {
			el.className = 'TOCcollapseAll'; 
			el.title='Collapse All';
		}
	}
	else {
		for(i=1;i<uls.length;i++){
			uls.item(i).style.display="none";
		}
		for(i=0;i<lis.length;i++){
			toggleClass(lis.item(i),OpenClass,ClosedClass);
		}
		collapseAll = false;
		el = document.getElementById("TOCexpandcollapseAll"); 
		if (el) {
			el.className = 'TOCexpandAll'; 
			el.title='Expand All';
		}
	}
}

/* **************************************** */
/* Expand TOC to the displayed target topic */
/* **************************************** */
function expandToItemURL(findURL,tocroot){
	if (findURL=="") return;
	//Remove the tailing slash / that is automatically added to the end of a URL by some browsers (not IE)
	findURL = findURL.replace(/\/$/,"");
	var a = document.createElement('a');
	a.href = findURL;
	findURL = a.href;
	
	resetSelected(tocroot);
	var ahrefs = tocroot.getElementsByTagName("a");
	var item,itemURL;
	var found=false;
	for(var i=0;i<ahrefs.length;i++){//find all occurences
		item = ahrefs.item(i);
		itemURL = item.href;
		itemURL = itemURL.replace(/\/$/,"");//Remove tailing slash /
		if (findURL.toLowerCase() == itemURL.toLowerCase()) {
			found=true;
//			if (i==0) break; //if it is the first topic then quit;
			//expand Parents
			var p = item.parentNode;
			addClass(p,SelectedClass);
			var doexpand = 0;
			while (p && p!=tocroot) {
				if (p.tagName) {
					if (hasClass(p,"liBullet")) {
						//current item is in a listbullet, so expand parents
						doexpand = 2;
					}
					if (hasClass(p,OpenClass) || hasClass(p,ClosedClass)) {
						//current item is in a container, skip that and expand parents of the current container, 
						//so do not expand the currently clicked, otherwise you can never collapse it (for mobile)
						doexpand += 1;
					}
					if (doexpand>1) {
						if (hasClass(p,ClosedClass)) {
							toggleClass(p,ClosedClass,OpenClass);
						}
					}
					if (doexpand>0) {
						if (p.style.display=="none") p.style.display="block"
					}
				}
				p = p.parentNode;
			}
			//set focus to next item,if possible), to move somewhat further
			//Note: does not work for IE which in overflow frame webHelp column width. IE shifts lines to left (icons dissapear)
			if (navigator.userAgent.search(/MSIE[ ]/i)==-1 && navigator.userAgent.search(/EIE10/i)==-1) {	
				if (i+1 < ahrefs.length) {
					ahrefs.item(i+1).focus();
				}
				item.focus();//then move focus back to founditem
			}
		}
	}
	return found;
}


// ============================================================================================================
// Class Helper functions
// ============================================================================================================
function hasClass(ele,cls) {
	return ele.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
}
function toggleClass(ele,fromClas, toClas) {
	removeClass(ele,fromClas);
	addClass(ele,toClas);
}
function addClass(ele,cls) {
	if (!this.hasClass(ele,cls)) ele.className += " "+cls;
}
 
function removeClass(ele,cls) {
	if (hasClass(ele,cls)) {
		var reg = new RegExp('(\\s|^)'+cls);
		var c = ele.className;
		c = c.replace(reg,'');
		c=c.replace(/(^\s+)|\s+$/g,"");//strip spaces
		ele.className=c;
	}
}

function getElementsByClassName(classname, node) {
	if(!node) node = document.getElementsByTagName("body")[0];
	var a = [];
	var re = new RegExp('\\b' + classname + '\\b');
	var els = node.getElementsByTagName("*");
	for(var i=0,j=els.length; i<j; i++){
		if(re.test(els[i].className)){
			a.push(els[i]);
		}
	}
	return a;
}
